Index: LMDZ5/branches/testing/libf/phylmd/cvltrorig.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cvltrorig.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/cvltrorig.F90	(revision 1750)
@@ -0,0 +1,166 @@
+!
+! $Id $
+!
+SUBROUTINE cvltrorig(it,pdtime,da, phi, mp,paprs,pplay,x,upd,dnd,dx)
+  USE dimphy
+  USE infotrac, ONLY : nbtr
+  IMPLICIT NONE 
+!=====================================================================
+! Objet : convection des traceurs / KE
+! Auteurs: M-A Filiberti and J-Y Grandpeix
+!=====================================================================
+  include "YOMCST.h"
+  include "YOECUMF.h" 
+
+! Entree
+  REAL,INTENT(IN)                           :: pdtime
+  INTEGER, INTENT(IN)                       :: it
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: da
+  REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: phi
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: mp
+  REAL,DIMENSION(klon,klev+1),INTENT(IN)    :: paprs ! pression aux 1/2 couches (bas en haut)
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: pplay ! pression pour le milieu de chaque couche
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(IN)      :: x     ! q de traceur (bas en haut) 
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: upd   ! saturated updraft mass flux
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: dnd   ! saturated downdraft mass flux
+
+! Sortie
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT) :: dx ! tendance de traceur  (bas en haut)
+
+! Variables locales     
+! REAL,DIMENSION(klon,klev)       :: zed
+  REAL,DIMENSION(klon,klev,klev)  :: zmd
+  REAL,DIMENSION(klon,klev,klev)  :: za
+  REAL,DIMENSION(klon,klev)       :: zmfd,zmfa
+  REAL,DIMENSION(klon,klev)       :: zmfp,zmfu
+  REAL,DIMENSION(klon,klev)       :: deltap
+  INTEGER                         :: i,k,j 
+  REAL                            :: pdtimeRG
+!!  real conserv
+
+! =========================================
+! calcul des tendances liees au downdraft
+! =========================================
+!cdir collapse
+  DO j=1,klev
+  DO i=1,klon
+!   zed(i,j)=0.
+    zmfd(i,j)=0.
+    zmfa(i,j)=0.
+    zmfu(i,j)=0.
+    zmfp(i,j)=0.
+  END DO
+  END DO
+!cdir collapse
+  DO k=1,klev
+  DO j=1,klev
+  DO i=1,klon
+    zmd(i,j,k)=0.
+    za (i,j,k)=0.
+  END DO
+  END DO
+  END DO
+! entrainement
+! DO k=1,klev-1
+!    DO i=1,klon
+!       zed(i,k)=max(0.,mp(i,k)-mp(i,k+1))
+!    END DO
+! END DO
+
+! calcul de la matrice d echange
+! matrice de distribution de la masse entrainee en k
+
+  DO k=1,klev-1
+     DO i=1,klon
+        zmd(i,k,k)=max(0.,mp(i,k)-mp(i,k+1))
+     END DO
+  END DO
+  DO k=2,klev
+     DO j=k-1,1,-1
+        DO i=1,klon
+           if(mp(i,j+1).ne.0) then
+              zmd(i,j,k)=zmd(i,j+1,k)*min(1.,mp(i,j)/mp(i,j+1))
+           ENDif
+        END DO
+     END DO
+  END DO
+  DO k=1,klev
+     DO j=1,klev-1
+        DO i=1,klon
+           za(i,j,k)=max(0.,zmd(i,j+1,k)-zmd(i,j,k))
+        END DO
+     END DO
+  END DO
+!
+! rajout du terme lie a l ascendance induite
+!
+  DO j=2,klev
+     DO i=1,klon
+        za(i,j,j-1)=za(i,j,j-1)+mp(i,j)
+     END DO
+  END DO
+!
+! tendances
+!            
+  DO k=1,klev
+     DO j=1,klev
+        DO i=1,klon
+           zmfd(i,j)=zmfd(i,j)+za(i,j,k)*(x(i,k,it)-x(i,j,it))
+        END DO
+     END DO
+  END DO
+!
+! =========================================
+! calcul des tendances liees aux flux satures
+! =========================================
+  DO j=1,klev
+     DO i=1,klon
+        zmfa(i,j)=da(i,j)*(x(i,1,it)-x(i,j,it))
+     END DO
+  END DO
+  DO k=1,klev
+     DO j=1,klev
+        DO i=1,klon
+           zmfp(i,j)=zmfp(i,j)+phi(i,j,k)*(x(i,k,it)-x(i,j,it))
+        END DO
+     END DO
+  END DO
+  DO j=1,klev-1
+     DO i=1,klon
+        zmfu(i,j)=max(0.,upd(i,j+1)+dnd(i,j+1))*(x(i,j+1,it)-x(i,j,it))
+     END DO
+  END DO
+  DO j=2,klev
+     DO i=1,klon
+        zmfu(i,j)=zmfu(i,j)+min(0.,upd(i,j)+dnd(i,j))*(x(i,j,it)-x(i,j-1,it))
+     END DO
+  END DO
+
+! =========================================
+! calcul final des tendances
+! =========================================
+  DO k=1, klev
+     DO i=1, klon
+        deltap(i,k)=paprs(i,k)-paprs(i,k+1)
+     ENDDO
+  ENDDO
+  pdtimeRG=pdtime*RG
+!cdir collapse
+  DO k=1, klev
+     DO i=1, klon
+        dx(i,k,it)=(zmfd(i,k)+zmfu(i,k)       &
+                +zmfa(i,k)+zmfp(i,k))*pdtimeRG/deltap(i,k)
+     ENDDO
+  ENDDO
+
+! test de conservation du traceur
+!      conserv=0.
+!      DO k=1, klev
+!        DO i=1, klon
+!         conserv=conserv+dx(i,k,it)*   &
+!          deltap(i,k)/RG
+!        ENDDO
+!      ENDDO
+!      print *,'it',it,'cvltrorig conserv',conserv
+     
+END SUBROUTINE cvltrorig
Index: LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90	(revision 1750)
@@ -99,5 +99,5 @@
   REAL    :: dummy
   LOGICAL :: ok_newmicro, ok_journe, ok_mensuel, ok_instan, ok_hf
-  LOGICAL :: ok_LES, ok_ade, ok_aie, aerosol_couple, new_aod, callstats
+  LOGICAL :: ok_LES, ok_ade, ok_aie, ok_cdnc, aerosol_couple, new_aod, callstats
   INTEGER :: iflag_radia, flag_aerosol
   REAL    :: bl95_b0, bl95_b1, fact_cldcon, facttemps, ratqsbas, ratqshaut
@@ -136,5 +136,5 @@
                    iflag_cldcon,                                        &
                    iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs,            &
-                   ok_ade, ok_aie, aerosol_couple,                      &
+                   ok_ade, ok_aie, ok_cdnc, aerosol_couple,             &
                    flag_aerosol, new_aod,                               &
                    bl95_b0, bl95_b1,                                    &
@@ -437,5 +437,6 @@
 ! Writing
 !*******************************************************************************
-  CALL inidissip(lstardis,nitergdiv,nitergrot,niterh,tetagdiv,tetagrot,tetatemp)
+  CALL inidissip(lstardis, nitergdiv, nitergrot, niterh, tetagdiv, tetagrot, &
+       tetatemp, vert_prof_dissip)
   WRITE(lunout,*)'sortie inidissip'
   itau=0
Index: LMDZ5/branches/testing/libf/phylmd/evappot.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/evappot.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/evappot.F90	(revision 1750)
@@ -0,0 +1,42 @@
+SUBROUTINE evappot(klon,nbsrf,ftsol,pplay,cdragh,  &
+       &    t_seri,q_seri,u_seri,v_seri,evap_pot)
+
+IMPLICIT NONE
+
+#include "YOMCST.h"
+#include "YOETHF.h"
+#include "FCTTRE.h"
+
+
+INTEGER :: klon, nbsrf
+REAL, DIMENSION(klon,nbsrf) :: ftsol,evap_pot
+REAL, DIMENSION(klon) :: pplay,t_seri,wind,q_seri,u_seri,v_seri,cdragh
+
+INTEGER :: nsrf,i
+REAL, DIMENSION(klon,nbsrf) :: qsat_ftsol
+REAL, DIMENSION(klon) :: rhos, norme_u
+REAL :: t_coup
+
+      t_coup=234.   ! Quelle horreur !!!!!
+
+DO nsrf = 1, nbsrf
+   DO i = 1, klon
+      IF (ftsol(i,nsrf).LT.t_coup) THEN
+         qsat_ftsol(i,nsrf) = qsats(ftsol(i,nsrf))/pplay(i)
+      ELSE
+         qsat_ftsol(i,nsrf) = qsatl(ftsol(i,nsrf))/pplay(i)
+      ENDIF
+   ENDDO
+ENDDO
+! ========================================================== c
+! Calcul de l'evaporation Potentielle
+
+
+rhos(:) = pplay(:)/(RD*t_seri(:))
+norme_u(:)=1.+sqrt(u_seri(:)*u_seri(:)+v_seri(:)*v_seri(:))
+DO nsrf = 1, nbsrf
+  evap_pot(:,nsrf)=rhos(:)*cdragh(:)*norme_u(:)*(qsat_ftsol(:,nsrf)-q_seri(:))
+ENDDO
+RETURN
+
+END
Index: LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 1750)
@@ -4,8 +4,8 @@
 !
 SUBROUTINE fisrtilp(dtime,paprs,pplay,t,q,ptconv,ratqs, &
-     d_t, d_q, d_ql, rneb, radliq, rain, snow, &
-     pfrac_impa, pfrac_nucl, pfrac_1nucl, &
-     frac_impa, frac_nucl, &
-     prfl, psfl, rhcl, zqta, fraca, &
+     d_t, d_q, d_ql, rneb, radliq, rain, snow,          &
+     pfrac_impa, pfrac_nucl, pfrac_1nucl,               &
+     frac_impa, frac_nucl, beta,                        &
+     prfl, psfl, rhcl, zqta, fraca,                     &
      ztv, zpspsk, ztla, zthl, iflag_cldcon)
 
@@ -124,4 +124,7 @@
   REAL zprec_cond(klon)
   !AA
+! RomP >>> 15 nov 2012
+  REAL   beta(klon,klev) ! taux de conversion de l'eau cond
+! RomP <<<
   REAL zmair, zcpair, zcpeau
   !     Pour la conversion eau-neige
@@ -171,4 +174,5 @@
            pfrac_1nucl(i,k)=1.
            pfrac_impa(i,k)=1.
+           beta(i,k)=0.  !RomP initialisation
         ENDDO
      ENDDO
@@ -549,4 +553,9 @@
      DO i = 1,klon
         !
+        if(zcond(i).gt.zoliq(i)+1.e-10) then
+         beta(i,k) = (zcond(i)-zoliq(i))/zcond(i)/dtime
+        else
+         beta(i,k) = 0.
+        endif
         zprec_cond(i) = MAX(zcond(i)-zoliq(i),0.0) &
              * (paprs(i,k)-paprs(i,k+1))/RG
Index: LMDZ5/branches/testing/libf/phylmd/ini_histrac.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/ini_histrac.h	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/ini_histrac.h	(revision 1750)
@@ -4,7 +4,11 @@
   IF (ecrit_tra>0.) THEN
 !$OMP MASTER 
-     CALL ymds2ju(annee_ref, 1, day_ref, 0.0, zjulian)
+!!!     CALL ymds2ju(annee_ref, 1, day_ref, 0.0, zjulian)
+! correction pour l heure initiale                               !jyg 
+!                                                               !jyg 
+      CALL ymds2ju(annee_ref, 1, day_ref, hour, zjulian)         !jyg
+
      CALL histbeg_phy("histrac", itau_phy, zjulian, pdtphys,nhori, nid_tra)
-     CALL histvert(nid_tra, "presnivs", "Vertical levels", "mb",klev, presnivs, nvert)
+     CALL histvert(nid_tra, "presnivs", "Vertical levels", "Pa",klev, presnivs, nvert,"down")
 
      zsto = pdtphys
@@ -17,4 +21,9 @@
           "kg m-2", iim, jj_nb, nhori, klev, 1, klev, nvert, 32, "ave(X)", &
           zsto,zout)
+! RomP >>>
+     CALL histdef(nid_tra, "sourceBE", "source 7Be", &
+          "at/kgA/s", iim, jj_nb, nhori, klev, 1, klev, nvert, 32, "ave(X)", &
+          zsto,zout)
+! RomP <<<
 
 !TRACEURS
@@ -30,7 +39,28 @@
         IF (lessivage .AND. aerosol(it)) THEN
            CALL histdef(nid_tra, "fl"//tname(iiq),"Flux "//ttext(iiq), &
-                "U/m2/s",iim,jj_nb,nhori, klev,1,klev,nvert, 32,       &
-                "ave(X)", zsto,zout)
-        END IF
+                "at/m2/s",iim,jj_nb,nhori, klev,1,klev,nvert, 32,       &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "d_tr_ls_"//tname(iiq),      &
+                "tendance lessivage large scale"// ttext(iiq), "?",&
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,       &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "d_tr_insc_"//tname(iiq),      &
+                "tendance lessivage large scale"// ttext(iiq), "?",&
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,       &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "d_tr_bcscav_"//tname(iiq),      &
+                "tendance lessivage large scale"// ttext(iiq), "?",&
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,       &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "d_tr_evls_"//tname(iiq),      &
+                "tendance lessivage large scale"// ttext(iiq), "?",&
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,       &
+                "ave(X)", zsto,zout)
+!  Tracer concentration in LS precipitation at surface
+           CALL histdef(nid_tra, "qpr_ls_"//tname(iiq),       &
+                "concentration in LS precip"// ttext(iiq), "at/kgw", &
+                iim,jj_nb,nhori, 1,1,1, -99, 32,                 &
+                "ave(X)", zsto,zout)     
+                 END IF
 
 ! TD THERMIQUES
@@ -50,10 +80,97 @@
         ENDIF
 
+! RomP >>>
+        IF (iflag_con.EQ.30) THEN
+           CALL histdef(nid_tra, "d_tr_cvMA_"//tname(iiq),   &
+                "tendance convection"// ttext(iiq), "?",&
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,    &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "d_tr_trsp_"//tname(iiq),   &
+                "tendance transport "// ttext(iiq), "at/kga",   &
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,    &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "d_tr_sscav_"//tname(iiq),   &
+                "tendance lessivage flux satures "// ttext(iiq), "at/kga",   &
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,    &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "d_tr_sat_"//tname(iiq),   &
+                "tendance flux satures "// ttext(iiq), "at/kga",  &
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,    &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "d_tr_uscav_"//tname(iiq),  &
+                "tendance flux insatures "// ttext(iiq), "at/kga", &
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,    &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "tr_pr_"//tname(iiq),  &
+                "concentration dans precip"// ttext(iiq), "at/kga", &
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,    &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "tr_aa_"//tname(iiq),  &
+                "concentration precip issu AA"// ttext(iiq), "at/kga", &
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,    &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "tr_mel_"//tname(iiq),  &
+                "concentration precip issu melange"// ttext(iiq), "at/kga", &
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,    &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "tr_di_"//tname(iiq),  &
+                "concentration dans descente insaturee"// ttext(iiq), "at/kga", &
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,    &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "tr_trspdi_"//tname(iiq),  &
+                "conc descente insaturee MA"// ttext(iiq), "at/kga", &
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,    &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "zmfd1a_"//tname(iiq),  &
+                "zmfd1a"// ttext(iiq), "_", &
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,    &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "zmfphi2_"//tname(iiq),  &
+                "zmfphi2"// ttext(iiq), "_", &
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,    &
+                "ave(X)", zsto,zout)
+           CALL histdef(nid_tra, "zmfdam_"//tname(iiq),  &
+                "zmfdam"// ttext(iiq), "_", &
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,    &
+                "ave(X)", zsto,zout)
+          ENDIF
+! RomP <<<
+           CALL histdef(nid_tra, "dtrdyn_"//tname(iiq),  &
+                "td dyn tra"// ttext(iiq), "at/kga", &
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,  &
+                "ave(X)", zsto,zout)
+! TD decroissance radioactive
+           CALL histdef(nid_tra, "d_tr_dec_"//tname(iiq),   &
+                "tendance decroi radio "// ttext(iiq), "",  &
+                iim,jj_nb,nhori, klev,1,klev,nvert, 32,  &
+                "ave(X)", zsto,zout)
+
 ! TD COUCHE-LIMITE
+      IF (couchelimite) THEN
         CALL histdef(nid_tra, "d_tr_cl_"//tname(iiq),      &
              "tendance couche limite"// ttext(iiq), "?",   &
              iim,jj_nb,nhori, klev,1,klev,nvert, 32,       &
              "ave(X)", zsto,zout)
+!  Dry deposit (1st layer and surface)
+        CALL histdef(nid_tra, "d_tr_dry_"//tname(iiq),       &
+             "tendancy dry deposit"// ttext(iiq), "at/kga/step", &
+             iim,jj_nb,nhori, 1,1,1, -99, 32,                 &
+             "ave(X)", zsto,zout)     
+        CALL histdef(nid_tra, "flux_tr_dry_"//tname(iiq),       &
+             "dry deposit at surf (downward)"// ttext(iiq), "at/m2/step", &
+             iim,jj_nb,nhori, 1,1,1, -99, 32,                 &
+             "ave(X)", zsto,zout)     
+      ENDIF
      ENDDO
+
+     CALL histdef(nid_tra, "Mint", "Mint","",         &
+          iim,jj_nb,nhori, klev,1,klev,nvert, 32,          &
+          "inst(X)", zout,zout)
+     CALL histdef(nid_tra, "frac_impa", "frac_impa","",         &
+          iim,jj_nb,nhori, klev,1,klev,nvert, 32,          &
+          "inst(X)", zout,zout)
+     CALL histdef(nid_tra, "frac_nucl", "frac_nucl","",         &
+          iim,jj_nb,nhori, klev,1,klev,nvert, 32,          &
+          "inst(X)", zout,zout)
 !---------------   
 !
